#include <pthread.h>
#include <resolv.h>

/* For backwards compatibility. */
int res_querydomain(char *name, char *domain, int class, int type,
		    unsigned char *answer, int anslen)
{
    char buf[2 * MAXDNAME + 2];
    char *longname = buf;
    int len;

    if (domain == NULL) {
	/* Check for trailing '.'; copy without '.' if present. */
	len = strlen(name);
	if (len > 0 && name[len - 1] == '.' && len < sizeof(buf)) {
	    memcpy(buf, name, len - 1);
	    buf[len - 1] = '\0';
	} else {
	    longname = name;
	}
    } else {
	sprintf(buf, "%.*s.%.*s", MAXDNAME, name, MAXDNAME, domain);
    }

    return (res_query(longname, class, type, answer, anslen));
}

